c....&................................................................72
      implicit none
      integer ngr,iyear,iy1,iy2,ig,nm,m,nd,ndy,idn,ileap
      parameter (nm=12,ndy=366)
      character*200 dir,file_in,file_out
      character*4 year
      character*40 wform
      real*8 ylongi,ylati,fsol(nm),solday_toa,zen,solmth_toa
     &      ,daylen,daylmth,sunh_pc(nm)
      real*8 sunea,exc,obl,xlsper
      real*8 ftrmin,ftrmax
      integer mlength(nm),ini(nm),ifin(nm),imonth(ndy)
            
c PIXEL NUMBER -> ngr
      ngr = 1859
      dir = '/raid3/umccb/clim0017/stughilain/caraib/clim/'//
     &'Belgium/MAR/'      
      
      ileap = 1
      iy1 = 2010
      iy2 = 2010
      
      sunea = 1368.
      exc = 0.0416667
      obl = 23.447
      xlsper = 282.16
      
      ftrmin = 0.251
      ftrmax = 0.760
            
      do iyear = iy1, iy2
       write(year,'(i4)')iyear
       call leap_year(iyear,nd)
       call monthparam(nd,ini,ifin,imonth)
       write(*,'(a6,a4)')'Year: ',year
c       write(*,*)'nd= ',nd       
       do m = 1, nm
        mlength(m)=ifin(m)-ini(m)+1
c	write(*,*)m,mlength(m),ini(m),ifin(m)
       end do       
       file_in = trim(dir)//'fsol_WC.dat'
       open(1,file=file_in)
       file_out = trim(dir)//'shr_WC.dat'
       open(10,file=file_out)       
       do ig = 1, ngr
        read(1,*)ylongi,ylati,(fsol(m),m=1,nm)
c	write(*,*)' ng: ',ig,' lat: ',ylati
	do m = 1, nm
	 solmth_toa = 0.
	 daylmth = 0.
	 do idn=ini(m),ifin(m)
	  call solar_toa(idn,ileap,ylati,sunea,exc,obl,xlsper
     &          ,solday_toa,zen,daylen)
          solmth_toa = solmth_toa+solday_toa/mlength(m)
	  daylmth = daylmth+daylen/mlength(m)
         end do
         if (daylmth.ge.1.d-10) then 
          sunh_pc(m)=100.*((fsol(m)/solmth_toa)-ftrmin)/(ftrmax-ftrmin)
          if (sunh_pc(m).le.0.) sunh_pc(m)=0.
          if (sunh_pc(m).ge.100.) sunh_pc(m)=100.
         else
           sunh_pc(m)=0.
         endif
c	 write(*,'(i2,4(1x,f10.4))')m,fsol(m),solmth_toa,sunh_pc(m)
c     &       ,daylmth
	end do
        write(wform,*)'(2(1x,f8.3),',nm,'(1x,f6.2))'       
        write(10,wform)ylongi,ylati,(sunh_pc(m),m=1,nm)	
       end do
       close (1)
       close (10)
      end do
      
      
      stop
      end
       
      
       
       
      
      
       
c=======================================================================
c***********************************************************************
      subroutine solar_toa(idn,ileap,ylati,sunea,exc,obl,xlsper
     &          ,solday_toa,zen,daylen)
c***********************************************************************
c=======================================================================

c=======================================================================
c   calculates the solar irradiance at the top of the atmosphere 
c
c   inputs:   idn   = day number (dimensionless)
c             ileap = flag to account for leap years 
c                     (ileap=0 - no leap year / ileap=1 leap years)
c             ylati = latitude of the grid point studied (deg.)
c             sunea = solar constant (W m-2)
c             exc   = eccentricity of the Earth's orbit (dimensionless)
c             obl   = obliquity (deg.)
c             xlsper = longitude of perihelion from vernal equinox 
c                     (deg.)
c            
c
c   outputs:  solday_toa = daily mean value of the solar irradiance
c                      at the top of the atmosphere (W m-2)
c             zen = average zenith angle of the sun over the day (deg.)
c             daylen = day length (hr)
c
c=======================================================================


      IMPLICIT NONE      
      integer idn,ileap
      real*8 ylati,sunea, exc,obl,xlsper,solday_toa,zen,daylen
      real*8 pi,pi180,ylati_rad,obl_rad,xlsper_rad,pi365,dn,slg,th,sth
      real*8 xls,theta,rm,sdel,cdel,cte,sxlt,cxlt,ch0,h0,cz0

c a well-known number
      pi = 3.1415926535
      
c conversion of angles in radians
      pi180 = pi/180.d+0
      ylati_rad = ylati*pi180
      obl_rad = obl*pi180
      xlsper_rad = xlsper*pi180
      
      if (ileap.eq.1) then 
       pi365   = 2. * pi / 365.2425
      else
       pi365   = 2. * pi / 365.
      endif      

      dn = float(idn-1)

c=======================================================================
c   calculates necessary angles:
c   sdel  = sinus of solar declination;
c   h0    = solar hour angle at sunset
c=======================================================================

      slg   = pi365 * (dn - 79.092)
      if (slg .lt. 0.) slg = 2. * pi + slg
      th    = slg - xlsper_rad
      sth   = dsin(th)
      xls   = slg + 2.*sth*exc + 2.5*sth*dcos(th)*exc*exc
     &        + (3.*sth - 13.*sth*sth*sth/3.) * exc * exc * exc
      theta = xls - xlsper_rad
      rm    = (1. - exc*exc) / (1. + exc*dcos(theta))
      sdel  = sin(obl_rad) * sin(xls)
      cdel  = dsqrt(1.-sdel*sdel)
      cte   = sunea / (rm * rm)

      sxlt  = sin(ylati_rad)
      cxlt  = cos(ylati_rad)
      if(cxlt .le. 1.d-20) cxlt = 1.d-20

      ch0   = -sxlt * sdel / (cxlt * cdel)
      if(ch0 .ge. 1.) then
        h0 = 0.
      else
        if(ch0 .le. -1) then
          h0 = pi
        else
          h0 = acos(ch0)
        endif
      endif

c=======================================================================
c   calculates the mean cosine of the solar zenith angle.
c=======================================================================

      cz0 = (h0 * sxlt * sdel + cxlt * cdel * dsin(h0)) / pi
      
c=======================================================================
c   calculates daily solar irradiance at the top of the atmosphere,
c   daily mean solar zenith angle and day length
c=======================================================================      
      solday_toa = cte*cz0
      zen = acos(cz0)/pi180
      daylen = 24.*h0/pi     

      return
      end


c=======================================================================
      subroutine leap_year(iy,nd)
c=======================================================================
      
      implicit none
      integer iy,nd
      integer r100,r4,icentury      

c Determination of leap years according to year number    
c ----------------------------------------------------
c iy must be set to the year number in the Gregorian calendar
c nd = number of days in the current year

        r100 = mod(iy,100)
        if (r100.eq.0) then
         icentury = iy/100
	 r4 = mod(icentury,4)
        else     
         r4 = mod(iy,4)
        endif 
        if (r4.eq.0) then 
         nd = 366 
        else
	 nd = 365
        endif      

      return
      end


c=======================================================================
c***********************************************************************
      subroutine monthparam(nd,ini,ifin,imonth)
c***********************************************************************
c=======================================================================
c=======================================================================
c   reads constants for weather generator and 'sets' them in commons
c   variables declaration
c=======================================================================
      implicit none
      integer nm,nd,ndy
      parameter (nm=12,ndy=366)      
      integer mlength(nm),ini(nm),ifin(nm),imonth(ndy)
      integer m,iday
     
c=======================================================================
c   reference times for the seasonal cycle modeling:
c
c   imonth = month corresponding to each day;
c   mlength = length of each month;
c   numday  = representative day for each month.
c=======================================================================

      data mlength /31,28,31,30,31,30,31,31,30,31,30,31/
      
      if (nd.eq.366) then
        mlength(2) = 29
      else
        mlength(2) = 28
      endif


      do iday = 1, nd
         imonth(iday) = 1
      enddo
      
      ini(1) = 1
      ifin(1) = mlength(1)
      do m = 2, nm
	 ini(m) = ini(m-1) + mlength(m-1)
	 ifin(m) = ifin(m-1) + mlength(m)
         do iday = ini(m), ifin(m)
            imonth(iday) = m
         enddo
      enddo
      

      return
      end
