;........1.........2.........3.........4.........5.........6.........7.........8

pro map_plot,lg,lat,var_V,win,MAP_TITLE=map_title,MAPLIM=maplim,RESOL=resol,LON_LAB=lon_lab,LAT_LAB=lat_lab,IGRID=igrid,ICONT=icont,XTIC_DAT=xtic_dat,XTIC_LAB=xtic_lab,FORMAT_TICLAB=format_ticlab,CHSIZE=chsize,PROJECTION_NAME=projection_name,PROJECTION_CENTER=projection_center,TOP_MARGIN=top_margin,POLYFILE=polyfile,PIXEL_CONTOUR=pixel_contour,SITE_DATA=site_data,SITE_THRESHOLD=site_threshold,SITE_ABSENCE=site_absence


  !p.multi(0)=win 
inoveg = 0
dircol = 1
jplalldiv = 1

;color_scale_10,r,g,b

size_lg=size(lg)
size_lat=size(lat)
size_varV=size(var_V)

if (size_lg(0) ne 1) or (size_lat(0) ne 1) or (size_varV(0) ne 1) then begin 
   print,'lg, lat and var_V must be one-dimensional vectors with the same number of elements '
   print,'Execution aborted in procedure map_plot'
   stop
endif else begin
 if (size_lg(1) ne size_lat(1)) or (size_lg(1) ne size_varV(1)) then begin
   print,'lg, lat and var_V must be one-dimensional vectors with the same number of elements '
   print,'Execution aborted in procedure map_plot'
   stop
 endif else begin
   dim0 = size_varV(1) 
 endelse 
endelse
print,'dim0 = ',dim0

if KEYWORD_SET(maplim) then begin
 size_maplim = size(maplim)
 if (size_maplim(0) eq 1) and (size_maplim(1) eq 4) then begin 
   log1 = maplim(0)
   lat1 = maplim(1)
   log2 = maplim(2)
   lat2 = maplim(3)
 endif else begin 
   print,'MAPLIM must be a 4-element vector containing longitude and latitude limits of the map'
   print,'Execution aborted in procedure map_plot'
   stop
 endelse   
endif else begin
 lat1 = fix(min(lat))
 log1 = fix(min(lg))
 lat2 = fix(max(lat)+1.)
 log2 = fix(max(lg)+1.)
endelse

print,log1,lat1,log2,lat2

if KEYWORD_SET(resol) then begin
 size_resol = size(resol)
 if size_resol(0) eq 1 then begin
     dlg = resol(0)
     dlt = resol(1)
 endif else begin
   if size_resol(0) eq 0 then begin
     dlg = resol
     dlt = resol
   endif else begin
     print,'RESOL must be a scalar or a 2-element vector containing longitude/latitude resolution in degrees'
     print,'Execution aborted in procedure map_plot'
     stop
   endelse
 endelse
endif else begin
 dlg = 0.5
 dlt = 0.5
endelse    

if KEYWORD_SET(chsize) then chs=chsize else chs=1

if KEYWORD_SET(lon_lab) then begin
 size_lonlab = size(lon_lab)
 if (size_lonlab(0) eq 1) and (size_lonlab(1) ge 2) then begin
   nlon_grid = size_lonlab(1)-1 
 endif else begin 
   print,'LON_LAB must be a vector containing at least two elements'
   print,'Execution aborted in procedure map_plot'
   stop
 endelse
endif else begin
 nlon_grid = 6
 lon_lab=fltarr(nlon_grid+1)
 del_lon=(log2-log1)/nlon_grid
 for k=0,nlon_grid do lon_lab(k)=log1+k*del_lon
endelse

if KEYWORD_SET(lat_lab) then begin
 size_latlab = size(lat_lab)
 if (size_latlab(0) eq 1) and (size_latlab(1) ge 2) then begin
   nlat_grid = size_latlab(1)-1 
 endif else begin 
   print,'LAT_LAB must be a vector containing at least two elements'
   print,'Execution aborted in procedure map_plot'
   stop
 endelse
endif else begin
 nlat_grid = 6
 lat_lab=fltarr(nlat_grid+1)
 del_lat=(lat2-lat1)/nlat_grid
 for k=0,nlat_grid do lat_lab(k)=lat1+k*del_lat
endelse

if KEYWORD_SET(top_margin) then ymarup=top_margin else ymarup = 8


iclass = 0

if KEYWORD_SET(xtic_dat) then begin
 size_xticdat = size(xtic_dat)
 if (size_xticdat(0) eq 1) then begin
   ndiv = size_xticdat(1)-1
 endif else begin
  if (size_xticdat(0) eq 0) then begin
   ndiv = 0
  endif else begin 
   print,'XTIC_DAT must be a scalar or a one-dimensional vector with at least one element'
   print,'Execution aborted in procedure map_plot'  
   stop
  endelse
 endelse
 if KEYWORD_SET(xtic_lab) then begin
  size_xticlab = size(xtic_lab)
  if (size_xticlab(0) eq 1) and (size_xticlab(1) ge ndiv+2) and (size_xticlab(2) eq 7) then begin
   iclass = 1
  endif else begin
   print,'XTIC_LAB must be a string vector containing at least 1 more element than XTIC_DAT'
   print,'Execution aborted in procedure map_plot'  
   stop
  endelse
 endif
endif else begin
 ndiv = 18
 xtic_dat = fltarr(ndiv+1)
 xtic_dat(0) = min(0.,min(var_V))
 xtic_dat(ndiv) = max(var_V)
 deltic = (xtic_dat(ndiv)-xtic_dat(0))/float(ndiv)
 for k = 1, ndiv-1 do xtic_dat(k) = xtic_dat(k-1)+deltic 
endelse

if KEYWORD_SET(format_ticlab) then begin
 size_formatticlab = size(format_ticlab)
 if (size_formatticlab(0) eq 1) and (size_formatticlab(1) ge 4) and (size_formatticlab(2) eq 7) then begin
     formtic = format_ticlab(0)
     lowtic = format_ticlab(1)
     midtic = format_ticlab(2)
     hightic = format_ticlab(3)
 endif else begin
   if (size_formatticlab(0) eq 0) and (size_formatticlab(1) eq 7) then begin
     formtic = format_ticlab
     lowtic = ' < '
     midtic = ' - '
     hightic = ' > '
   endif else begin
     print,'FORMAT_TICLAB must be a scalar or a 4-element string vector containing format of/low and high tick labels'
     print,'Execution aborted in procedure map_plot'
     stop
   endelse
 endelse
endif else begin
 formtic = 'f10.3'
 lowtic = ' < '
 midtic = ' - '
 hightic = ' > '
endelse 

; ======= PLOT MAP =======================================================

icv = intarr(ndiv+2)
if dircol gt 0 then for j=0,ndiv+1 do icv(j)=j+1
if dircol lt 0 then for j=0,ndiv+1 do icv(j)=ndiv+2-j

jpl_div = intarr(ndiv+2)
if jplalldiv eq 0 then for j=0,ndiv+1 do jpl_div(j)=0 else for j=0,ndiv+1 do jpl_div(j)=1 

if KEYWORD_SET(projection_name) then begin 
 igpro = 1
 if KEYWORD_SET(projection_center) then begin
   size_pcenter = size(projection_center)
   if size_pcenter(0) ne 1 then begin 
     print,'PROJECTION_CENTER must be a one-dimensional vector of 2 or 3 elements' 
     print,'Execution aborted in procedure map_plot'
     stop
   endif 
   if (size_pcenter(1) le 1) or (size_pcenter(1) ge 4) then begin 
     print,'PROJECTION_CENTER must be a one-dimensional vector of 2 or 3 elements' 
     print,'Execution aborted in procedure map_plot'
     stop
   endif   
   p0_lon=projection_center(0)  
   p0_lat=projection_center(1) 
   rot=0
   if size_pcenter(1) eq 3 then rot=projection_center(2)      
   map_set,p0_lat,p0_lon,rot,limit=[lat1,log1,lat2,log2],name=projection_name,$
   ellipsoid=[6378137.0,0.00669437999014,0.9996],$
   xmargin=[10,25],ymargin=[4,ymarup],charsize=0.9*chs,title='',/noerase
 endif else begin   
   map_set,limit=[lat1,log1,lat2,log2],name=projection_name,$
   ellipsoid=[6378137.0,0.00669437999014,0.9996],$
   xmargin=[10,25],ymargin=[4,ymarup],charsize=0.9*chs,title='',/noerase 
 endelse

endif else begin
 igpro = 0
 plot,[log1,lat1],[log1,lat1],xrange=[log1,log2],yrange=[lat1,lat2],/nodata,/noerase,$
 xstyle=1,ystyle=1,xmargin=[10,25],ymargin=[4,ymarup],xticks=nlon_grid,$
 xtickv=lon_lab,yticks=nlat_grid,ytickv=lat_lab,$
 xtitle='Longitude (deg.)',ytitle='Latitude (deg.)',xcharsize=0.6*chs,ycharsize=0.6*chs,yticklen=-0.015,xticklen=-0.015
                           ; xmargin=[14,16]

 oplot,[log1,log2],[lat1,lat1],thick=2
 oplot,[log1,log1],[lat1,lat2],thick=2
 oplot,[log1,log2],[lat2,lat2],thick=2
 oplot,[log2,log2],[lat1,lat2],thick=2

endelse

if KEYWORD_SET(polyfile) then begin
 size_polyfile=size(polyfile)
 if (size_polyfile(0) eq 0) and (size_polyfile(1) eq 7) then begin
   close,80
   file80 = polyfile
   openr,80,file80
 ;   print,file80
 endif else begin
   print,'POLYFILE must be a zero-dimensional string' 
   print,'Execution aborted in procedure map_plot'
   stop   
 endelse
endif

 
    for i = long(0.), dim0-1 do begin
         if KEYWORD_SET(polyfile) then begin
	  polystring='  '
          readf,80,polystring
          reads,polystring,a1,a2,nver
	;  print,i,lg(i),lat(i),a1,a2,nver
          longv=fltarr(nver)
          latv=fltarr(nver)
          reads,polystring,a1,a2,nver,longv,latv  
	 endif     
      if lg(i) ge log1 and lg(i) le log2 then begin
       if lat(i) ge lat1 and lat(i) le lat2 then begin 
      ;    print,lg(i),lat(i),log1,log2,lat1,lat2
         if KEYWORD_SET(polyfile) then begin
	  lgvec=fltarr(nver+1)
	  ltvec=fltarr(nver+1)
	  ; print,i
	  ;  print,a1,a2,nver,longv,latv
          for nv=0,nver-1 do begin
;	    if longv(nv) lt -180. then longv(nv) = longv(nv) + 360.
;           if longv(nv) ge  180. then longv(nv) = longv(nv) - 360.
	   if longv(nv) lt log1 then longv(nv)=log1      
           if longv(nv) gt log2 then longv(nv)=log2
           if latv(nv) lt lat1 then latv(nv)=lat1
           if latv(nv) gt lat2 then latv(nv)=lat2
	   lgvec(nv)=longv(nv)
	   ltvec(nv)=latv(nv)
	  endfor
	  lgvec(nver)=lgvec(0)
	  ltvec(nver)=ltvec(0)	 
	 endif else begin    
          lg1 = lg(i)  - dlg/2.
          lg2 = lg(i)  + dlg/2.
          lt1 = lat(i) - dlt/2.
          lt2 = lat(i) + dlt/2.
          if lg1 lt log1 then lg1=log1      
          if lg2 gt log2 then lg2=log2
          if lt1 lt lat1 then lt1=lat1
          if lt2 gt lat2 then lt2=lat2
	  lgvec=[lg1,lg2,lg2,lg1,lg1]
	  ltvec=[lt1,lt1,lt2,lt2,lt1]   
	 endelse 
	   
	areapix = 1.23604116d+10*dlg*dlt*cos(lat(i)*3.14159/180.)
         
        for kk = 0, ndiv do begin
          if var_V(i) le xtic_dat(0) then begin 
	     ic = icv(0) 
	     kdiv = 0
	  endif else begin 
	   if var_V(i) ge xtic_dat(kk) then begin 
	     ic = icv(kk+1)
	     kdiv = kk+1
	   endif
	  endelse 
        endfor
        jpl_div(kdiv)=1
        polyfill,lgvec,ltvec,color=ic
	if KEYWORD_SET(pixel_contour) then oplot,lgvec,ltvec
       endif
      endif

    endfor
    
  if KEYWORD_SET(polyfile) then close,80
    
;  xyouts,longlab,latlab,label,alignment=0.,charsize = 1.0*chs
  
; ======= PLOT SITE DATA ==================================================

if KEYWORD_SET(site_data) then begin 
   size_sitedata=size(site_data)
   if (size_sitedata(0) eq 2) and (size_sitedata(2) eq 3) then begin 
    nsite = size_sitedata(1)
    site_long = fltarr(nsite)
    site_lat = fltarr(nsite)
    site_frac = fltarr(nsite)
    site_long(*) = site_data(*,0)
    site_lat(*) = site_data(*,1)
    site_frac(*) = site_data(*,2)
    endif else begin
    if (size_sitedata(0) eq 1) and (size_sitedata(1) eq 3) then begin
      nsite = 1
      site_long = fltarr(nsite)
      site_lat = fltarr(nsite)
      site_frac = fltarr(nsite)      
      site_long(0) = site_data(0)
      site_lat(0) = site_data(1)
      site_frac(0) = site_data(2)
    endif else begin   
      print,'site_data must be a 2-dimensional matrix: site_data(i,j)'
      print,'with i = 1, nsite, index for observed occurence/absence site pixels'
      print,'and containing 3 columns:
      print,'  - longitude of sites (j=0)'
      print,'  - latitude of sites (j=1)' 
      print,'  - occurence status of sites, i.e. 0./1. or probability of presence (j=2)'
      print,'Execution aborted in procedure map_plot'
      stop
    endelse 
   endelse

  if KEYWORD_SET(site_threshold) then fsite_thres = site_threshold else fsite_thres = 0.5  
     
   for js = 0, nsite-1 do begin
    frdat = site_frac(js)    
    lg1 = site_long(js)
    lg2 = site_long(js)
    lt1 = site_lat(js)
    lt2 = site_lat(js)    
    if (frdat ge fsite_thres)then begin 
;     for kk = 0, ndiv do begin
;         if frdat le xtic_dat(0) then begin 
;	     ic = icv(0) 
;	     kdiv = 0
;	  endif else begin 
;	   if frdat ge xtic_dat(kk) then begin 
;	     ic = icv(kk+1)
;	     kdiv = kk+1
;	   endif
;	  endelse         
;     endfor
;     jpl_div(kdiv)=1
   

     radius=0.7
     per=findgen(33)*(!pi*2./32.)    
     aa=radius*cos(per)
     bb=radius*sin(per)
     usersym,aa,bb,thick=2.0,color=200
     oplot,[lg1,lg2],[lt1,lt2],psym=1      
    endif else begin 
     if KEYWORD_SET(site_absence) then oplot,[lg1,lg2],[lt1,lt2],psym=4
    endelse
    
   endfor
  
endif
    
     
  
; ======= PLOT GRID -------------------------------------------------------

  if KEYWORD_SET(igrid) then begin
   tvlct,r,g,b,/get
   r(230)=140
   g(230)=140
   b(230)=140
   tvlct,r,g,b
   if igpro eq 0 then begin
    for k=0,nlon_grid do oplot,[lon_lab(k),lon_lab(k)],[lat1,lat2],line=1
    for k=0,nlat_grid do oplot,[log1,log2],[lat_lab(k),lat_lab(k)],line=1
   endif else begin
     xlglab = 0.5*(lat_lab(0)+lat_lab(1)) ; lat_lab(0)    ;
     xlgdel = lon_lab(1)-lon_lab(0)
     xltlab = lon_lab(nlon_grid)   ;0.5*(lon_lab(0)+lon_lab(1))
     xltdel = lat_lab(1)-lat_lab(0)
;    map_grid,/label,latlab=-12,latdel=10,lonlab=72,londel=10,charsize=0.8*chs
;    map_grid,/label,latlab=-35,latdel=5,lonlab=-35,londel=5,charsize=0.8*chs
     map_grid,/label,latlab=xltlab,latdel=xltdel,lonlab=xlglab,londel=xlgdel,charsize=0.8*chs,color=230
   endelse 
  endif
  
; ======= PLOT CONTINENTS -------------------------------------------------
  
  if KEYWORD_SET(icont) then begin
   if igpro eq 0 then begin
      contour_cont,filecont,resc_lg,resc_lt,ncont,igg_read,log1,log2,lat1,lat2,icont
   endif else begin
      map_continents,/countries,/coasts
;     if (kplot eq -21) then map_continents,/rivers,color=210 
   endelse
  endif

; ======= PLOT ELEVATION CONTOURS ----------------------------------------

  i_elevcont = 0 
  if i_elevcont eq 1 then begin
    close,90    
    openr,90,filecont
    
    nlgc=fix((log2-log1)/resc_lg+0.00001)
    nltc=fix((lat2-lat1)/resc_lt+0.00001)
    x=fltarr(nlgc,nltc)
    y=fltarr(nlgc,nltc)
    z=fltarr(nlgc,nltc)
    for ilg = 0,nlgc-1 do begin
     xlgc=log1+resc_lg*(0.5+ilg)
     x(ilg,*)=xlgc
    endfor
    for ilt = 0,nltc-1 do begin
     xltc=lat1+resc_lt*(0.5+ilt)
     y(*,ilt)=xltc
    endfor
    z(*,*)=-900.   
          
    for ig=long(0),ncont-long(1) do begin
     if igg_read eq 1 then begin
       readf,90,igg,xlgc,xltc,iii,cii,sii,sii,elev
     endif else begin
       readf,90,xlgc,xltc,elev
     endelse
     ilg = fix((xlgc-log1)/resc_lg)
     ilt = fix((xltc-lat1)/resc_lt)
     z(ilg,ilt) = elev
    endfor
    
    close,90
    xtic_ev  = [0,200,400,600,800,1000,1200,1400,1600,1800,2000,2200,2400,2600,2800,3000,3200,3400,3600,3800,4000,4200,4400,4600,4800,5000]
    clab_ev  =  [0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]
    clines_ev = [0,1,1,1,1,0,1,1,1,1,0,1,1,1,1,0,1,1,1,1,0,1,1,1,1,0]
;    contour,z,x,y,/overplot,/irregular,levels=xtic_ev,c_labels=clab_ev,c_linestyle=clines_ev,charsize=0.8*chs
    contour,z,x,y,/overplot,levels=xtic_ev,c_labels=clab_ev,c_linestyle=clines_ev,charsize=0.8*chs    
   endif
   

; ======= REPLOT MAP BORDER ==============================================
if igpro eq 0 then begin
  oplot,[log1,log2],[lat1,lat1]
  oplot,[log1,log2],[lat2,lat2]
  oplot,[log1,log1],[lat1,lat2] 
  oplot,[log2,log2],[lat1,lat2]
endif	        

; ======= PLOT COLOR SCALE ===========================================

 
 ; if ndiv ne 0 then !p.multi(0)=!p.multi(0)-1 else !p.multi(0)=!p.multi(0)-2
 
  !p.multi(0)=win
 
 plot,[0,0],[0,0],xstyle=5,ystyle=5,xrange=[0.,1.],$
      yrange=[0.,1.],/nodata,xmargin=[0,0],ymargin=[0,0],/noerase

 
 jinc_div = -1
 for j = 0,ndiv+1 do begin
  if jpl_div(j) eq 1 then begin
   jinc_div = jinc_div+1
   lg1 = 0.70   ;0.82   ;0.55        
   lg2 = lg1+0.03
   lt1 = 0.11+jinc_div*0.033   ;0.045+jinc_div*0.033
   lt2 = lt1 + 0.025    ;lt1 + 0.025
   lt3 = lt1 + 0.003
   ic = icv(j) 
   polyfill,[lg1,lg2,lg2,lg1,lg1],[lt1,lt1,lt2,lt2,lt1],color=ic
      oplot,[lg1,lg2],[lt1,lt1]
      oplot,[lg1,lg2],[lt2,lt2]
      oplot,[lg1,lg1],[lt1,lt2]
      oplot,[lg2,lg2],[lt1,lt2]
   if iclass eq 1 then begin
    labtic=xtic_lab(j)  
   endif else begin
    if j eq 0 then begin
     form = '(1x,a3,'+formtic+')'
     labtic=string(format=form,lowtic,xtic_dat(j))
     if inoveg eq 1 then labtic = 'No vegetation'
    endif else if j eq ndiv+1 then begin
      form = '(1x,a3,'+formtic+')'   
      labtic=string(format=form,hightic,xtic_dat(j-1))
    endif else begin
      form = '(1x,'+formtic+',a3,'+formtic+')'  
      labtic=string(format=form,xtic_dat(j-1),midtic,xtic_dat(j))
      if inoveg eq 1 then begin
       if j eq 1 then begin
          form = '(1x,a3,'+formtic+')'
          labtic=string(format=form,lowtic,xtic_dat(j))
       endif
      endif    
    endelse
   endelse
   xyouts,lg2+0.01,lt3,labtic,charsize=0.88*chs   
  endif
 endfor

; ======= PLOT TITLE ===========================================


 
; if ianom eq 0 then begin
;    titre = graphname+varname
; endif else begin
;    if ianom eq 1 then titre = 'Anomalies of '+graphname+varname
;    if ianom eq 2 then titre = 'Increase factor of '+graphname+varname
; endelse
if KEYWORD_SET(map_title) then xyouts,0.16,0.94,map_title,alignment=0.,charsize = 1.5*chs

win = !p.multi(0)

return
end
