c....&................................................................72
      implicit none
      integer nlg_hr,nlt_hr,nlg_lr,nlt_lr,npix,ipix,m,ilg,ilt,klg,klt
      integer neig_lg,neig_lt,num,ilg_hr,ilt_hr
      integer ngr,igr,ilg_inf,ilg_sup,ilt_inf,ilt_sup
c  nlg_hr,nlt_hr : number of longitudes and latitudes in high resolution 
c     grid       
c      parameter (nlg_hr=960,nlt_hr=480)
      integer, dimension(:,:), allocatable :: isu_hr 
c      integer isu_hr(nlg_hr,nlt_hr)
      integer isu,num_isu(1000),iii,k,num_line,num_isumax
      real*4 xlg,xlt,var(5),fl
      real*4 xlgmin,xlgmax,xltmin,xltmax
      real*4 dlg_hr,dlt_hr,dlg,dlt,dlg_km,dlt_km
      real, dimension(:),allocatable :: xlg_hr
      real, dimension(:),allocatable :: xlt_hr      
      real, dimension(:,:),allocatable :: fl_hr
      real, dimension(:,:,:),allocatable :: var_hr      
c      real*4 xlg_hr(nlg_hr),xlt_hr(nlt_hr),var_hr(nlg_hr,nlt_hr,5)
c     &      ,fl_hr(nlg_hr,nlt_hr)
      real*4 areal,parea,pi,fland,areatot,sumtxt
      real*4 av_cla,av_sil,av_san,av_col,elvM


c=======================================================================
c This subroutine averages a high resoltion ecotxt file (from HWSD 
c at 30 arc sec resolution) on a low resolution kilometric grid
c======================================================================= 

c  name of input (high resolution) file for the mean (to be changed by user)      
      open(1,file='/raid3/umccb/clim0017/stughilain/caraib/clim/'//
     &'Belgium/WC2/ecotxt.dat')
      
c npix = number of pixels in this high resolution file 
c                                         (to be changed by user)    
      npix = 171803  

c  dlg_km, dlt_km : resolution (km) in longitude/latitude of the output   
c  grid over which the average is performed (to be defined by the user)     
c COSMO
c      dlg_km = 1.9284
c      dlt_km = 3.
c MAR
c      dlg_km = 10.
c      dlt_km = 10.
c ALARO
c      dlg_km = 5.
c      dlt_km = 5.

c  dlg, dlt : resolution (deg.) in longitude/latitude at the equator     
      dlg = dlg_km/111.112
      dlt = dlt_km/111.112
c COSMO
c      dlg = 0.027
c      dlt = 0.027
      dlg = 0.06666
      dlt = 0.06666

c  xlgmin, xlgmax xltmin, xltmax : minimum/maximum longitude and latitude of 
c  the zone (to be changed by user)      
c      xlgmin = 5.7
c      xlgmax = 6.6  
c      xltmin = 49.4 
c      xltmax = 50.2
      xlgmin = 1.75
      xlgmax = 7.0  
      xltmin = 49.25 
      xltmax = 51.75       
      
c resolution of the high resolution grid (30"=1/120 deg. for HWSD)      
      dlg_hr=1./120.
      dlt_hr=1./120.
      
c  name of file where long, lat of the low resolution grid are read
c      open(10,file='../clim/Luxemburg/COSMO/coordinates.dat')
c      open(10,file='../clim/Belgium/ALARO/elev.dat')
c  number of pixels in this low resolution grid
      ngr = 1859          
      

c  name of output file for the mean (to be changed by user)      
c      open(2,file='../clim/Luxemburg/COSMO/ecotxt.dat')
c      open(2,file='../clim/Belgium/ALARO/ecotxt.dat') 
      open(2,file='../clim/Belgium/ecotxt4m.dat')     
                 
c ======================================================================

      nlg_hr = int((xlgmax-xlgmin)/dlg_hr)+1
      nlt_hr = int((xltmax-xltmin)/dlt_hr)+1
      
      allocate(xlg_hr(nlg_hr))
      allocate(xlt_hr(nlt_hr))
      allocate(fl_hr(nlg_hr,nlt_hr))
      allocate(var_hr(nlg_hr,nlt_hr,5))
      allocate(isu_hr(nlg_hr,nlt_hr))

      pi=3.141592654
            
      do ilg=1,nlg_hr
       xlg_hr(ilg)=xlgmin+(float(ilg)-0.5)*dlg_hr
      end do
      do ilt=1,nlt_hr
       xlt_hr(ilt)=xltmin+(float(ilt)-0.5)*dlt_hr
      end do  
      
      do ilg=1,nlg_hr
       do ilt=1,nlt_hr
        do m=1,5
         var_hr(ilg,ilt,m)=-9999. 
	end do
	isu_hr(ilg,ilt)=-999
	fl_hr(ilg,ilt)=1.	
       end do
      end do       
     
      do ipix = 1, npix
       read(1,*)iii,xlg,xlt,isu,(var(m),m=1,5),fl
       ilg = 1 + int((xlg-xlgmin)/dlg_hr)
       ilt = 1 + int((xlt-xltmin)/dlt_hr)
       do m = 1, 5
        var_hr(ilg,ilt,m)=var(m)
       end do
       isu_hr(ilg,ilt)=isu
       fl_hr(ilg,ilt)=fl
      end do
      
      close (1)
      


      num_line= 0      
      do igr = 1, ngr
       read(10,*)xlg,xlt,elvM
       ilg = 1 + int((xlg-xlgmin)/dlg_hr)
       ilt = 1 + int((xlt-xltmin)/dlt_hr)
       neig_lg = int(0.5*dlg/(dlg_hr*cos(xlt*pi/180.)))
       neig_lt = int(0.5*dlt/dlt_hr)       
       ilg_inf=max(1,ilg-neig_lg)
       ilg_sup=min(nlg_hr,ilg+neig_lg)
       ilt_inf=max(1,ilt-neig_lt)
       ilt_sup=min(nlt_hr,ilt+neig_lt)
       num = 0
       areal = 0.
       areatot = 0.
       do m=1,5
	 var(m)=0.
       end do
       do k=1,1000
         num_isu(k)=0
       end do              
       do ilg_hr=ilg_inf,ilg_sup
        do ilt_hr=ilt_inf,ilt_sup
	    parea=1.23604306d+10*dlg_hr*dlt_hr
     &            *cos(xlt_hr(ilt_hr)*pi/180.)*fl_hr(ilg_hr,ilt_hr)
            areatot=areatot+parea	   
	    if (var_hr(ilg_hr,ilt_hr,1).gt.-9000.) then
	     num=num+1
             areal = areal+parea
	     do m = 1, 5
	      var(m) = var(m)+var_hr(ilg_hr,ilt_hr,m)*parea
	     end do
	     isu = isu_hr(ilg_hr,ilt_hr)
	     num_isu(isu)=num_isu(isu)+1	     
	    endif	 
        end do       
       end do
       if (num.ge.1) then
	     num_line = num_line + 1
	     fland = areal/areatot 
	     do m = 1, 5
	      var(m) = var(m)/areal
	     end do
	     num_isumax=-999
	     do k = 1, 1000
	      if (num_isu(k).gt.num_isumax) then
	        num_isumax=num_isu(k)
		isu = k
	      endif
	     end do	     	     
	     sumtxt=var(1)+var(2)+var(3)
	     if (abs(100.-sumtxt).ge.0.02)var(2)=100.-var(1)-var(3)
	     if (var(5).lt.0.) var(5)=0.
	     if (var(5).gt.1.) var(5)=1.
c	     xlg = (xlg_hr(ilg)+xlg_hr(ilg+neig_lg-1))/2.	   
c	     xlt = (xlt_hr(ilt)+xlt_hr(ilt+neig_lt-1))/2.
	     write(2,123)num_line,xlg,xlt,isu,(var(m),m=1,5),fland
       else
	     num_line = num_line + 1
	     fland = 0.000
	     isu = 1
	     av_col=0.5
	     av_cla=30.
	     av_sil=33.
	     av_san=37.
	     write(2,123)num_line,xlg,xlt,isu,av_cla,av_sil,av_san
     &                  ,elvM,av_col,fland	            
       endif              
      end do
      
123   format(i7,2(1x,f9.4),1x,i3,3(1x,f6.2),1x,f5.0,1x,f5.2,1x,f6.3)
      
      close (2)
      close (10)   

      deallocate (xlg_hr)
      deallocate (xlt_hr)
      deallocate (fl_hr)
      deallocate (var_hr)
      deallocate (isu_hr)      
          
      stop
      end      
       
      
