!=======================================================================
      MODULE MOD_NETCDFCARAIB
!=======================================================================

      IMPLICIT NONE

      INCLUDE 'netcdf.inc'
      
      ! *cooa for reading coordinates
      INTEGER, SAVE :: ncid_filcooa=0, ncvar_cooa=0      

      ! *wina corresponds to former unit 9
      INTEGER, SAVE :: ncid_filwina=0, ncvar_wina=0
      ! *winb corresponds to former unit 999
      INTEGER, SAVE :: ncid_filwinb=0, ncvar_winb=0
      REAL, SAVE :: ncfillvalue_wina, ncfillvalue_winb
      
      ! *rhua corresponds to former unit 8
      INTEGER, SAVE :: ncid_filrhua=0, ncvar_rhua=0
      ! *rhub corresponds to former unit 888
      INTEGER, SAVE :: ncid_filrhub=0, ncvar_rhub=0
      REAL, SAVE :: ncfillvalue_rhua, ncfillvalue_rhub
      
      ! *shra corresponds to former unit 7
      INTEGER, SAVE :: ncid_filshia=0, ncvar_shia=0
      ! *shrb corresponds to former unit 777
      INTEGER, SAVE :: ncid_filshib=0, ncvar_shib=0
      REAL, SAVE :: ncfillvalue_shia, ncfillvalue_shib

      ! *prca corresponds to former unit 4
      INTEGER, SAVE :: ncid_filprca=0, ncvar_prca=0
      ! *prcb corresponds to former unit 444
      INTEGER, SAVE :: ncid_filprcb=0, ncvar_prcb=0
      REAL, SAVE :: ncfillvalue_prca, ncfillvalue_prcb

      ! *dt1a corresponds to former unit 3 Tmax
      INTEGER, SAVE :: ncid_fildtaa=0, ncvar_dtaa=0
      ! *dt2b corresponds to former unit 333
      INTEGER, SAVE :: ncid_fildtab=0, ncvar_dtab=0
      REAL, SAVE :: ncfillvalue_dtaa, ncfillvalue_dtab
      ! *dt2a corresponds to former unit 3 Tmin
      INTEGER, SAVE :: ncid_fildtba=0, ncvar_dtba=0
      ! *dt2b corresponds to former unit 333
      INTEGER, SAVE :: ncid_fildtbb=0, ncvar_dtbb=0
      REAL, SAVE :: ncfillvalue_dtba, ncfillvalue_dtbb

      ! *tema corresponds to former unit 2
      INTEGER, SAVE :: ncid_filtema=0, ncvar_tema=0
      ! *temb corresponds to former unit 222
      INTEGER, SAVE :: ncid_filtemb=0, ncvar_temb=0
      REAL, SAVE :: ncfillvalue_tema, ncfillvalue_temb

      ! *tclima corresponds to former unit 81
      INTEGER, SAVE :: ncid_filtclima=0, ncvar_tclima=0
      REAL, SAVE :: ncfillvalue_tclima
      ! *pclima corresponds to former unit 82
      INTEGER, SAVE :: ncid_filpclima=0, ncvar_pclima=0
      REAL, SAVE :: ncfillvalue_pclima

      LOGICAL, SAVE :: l_gridinit_done = .FALSE.
      LOGICAL, SAVE :: l_timeinit_done = .FALSE.

      INTEGER :: ncdim_lon=0, ncdim_lat=0
      INTEGER :: nclen_lon=0, nclen_lat=0
      INTEGER :: ncvar_lon=0, ncvar_lat=0
      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:), SAVE :: zlon, zlat
      INTEGER, SAVE :: ncpos_lon=0, ncpos_lat=0
      DOUBLE PRECISION, SAVE :: zdel_lon, zdel_lat
      INTEGER :: ncdim_time=0
      INTEGER :: nclen_time=0
      INTEGER :: ncvar_time=0
      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:), SAVE :: ztime
      INTEGER, SAVE :: ncpos_time=0

      INTEGER, ALLOCATABLE, DIMENSION(:,:) :: ngt4ilonjlat
      INTEGER, ALLOCATABLE, DIMENSION(:)   :: ilon4ngt, jlat4ngt
 
      REAL, ALLOCATABLE, DIMENSION(:,:), SAVE :: tcel1year
      REAL, ALLOCATABLE, DIMENSION(:,:), SAVE :: temax1year
      REAL, ALLOCATABLE, DIMENSION(:,:), SAVE :: temin1year
      REAL, ALLOCATABLE, DIMENSION(:,:), SAVE :: sunhour1year
      REAL, ALLOCATABLE, DIMENSION(:,:), SAVE :: rhu1year
      REAL, ALLOCATABLE, DIMENSION(:,:), SAVE :: prc1year
      REAL, ALLOCATABLE, DIMENSION(:,:), SAVE :: win1year


!-----------------------------------------------------------------------
      CONTAINS
!-----------------------------------------------------------------------

      SUBROUTINE HANDLE_ERR(istatus)

      IMPLICIT NONE

      INCLUDE 'netcdf.inc' 

      INTEGER :: istatus

      IF (istatus /= NF_NOERR) THEN
        PRINT *, NF_STRERROR(istatus)
        PRINT *, 'NetCDF error detected; aborting.'
        CALL ABORT()
      ENDIF

      END SUBROUTINE HANDLE_ERR


      !*******************************************************
       SUBROUTINE HANDLE_NCERRORS(status, whatfile, whatline)
      !*******************************************************
!
      IMPLICIT NONE

      INCLUDE 'netcdf.inc' 

      INTEGER, INTENT(IN) :: status
      CHARACTER(LEN=*)    :: whatfile
      INTEGER, INTENT(IN) :: whatline

      IF (STATUS /= NF_NOERR) THEN
        IF(whatline > 0) THEN
          WRITE(*,'("[",A,":",I0,"]: ", A)')
     >      TRIM(whatfile), whatline, TRIM(NF_STRERROR(STATUS))
        ELSE
          WRITE(*,'("[",A,":???]: ", A)')
     >      TRIM(whatfile), TRIM(NF_STRERROR(STATUS))
        ENDIF
        PRINT *, 'NetCDF error detected; aborting.'
        CALL ABORT()
      ENDIF
      END SUBROUTINE HANDLE_NCERRORS
!

!=======================================================================
      END MODULE MOD_NETCDFCARAIB
!=======================================================================

